<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
	<title>VueJS Tabs</title>
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bulma@0.8.2/css/bulma.min.css">
</head>
<body>
	<div id="root" class="container">
		<tabs>
			<tab name="about us 1" :selected="true">
				<h1>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dignissimos iste itaque tempora impedit magnam, quia vitae reiciendis nesciunt doloremque accusamus totam quasi iure quod voluptas exercitationem illo sit nam voluptatibus.</h1>
			</tab>

			<tab name="about us 2">
				<h1>2 Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dignissimos iste itaque tempora impedit magnam, quia vitae reiciendis nesciunt doloremque accusamus totam quasi iure quod voluptas exercitationem illo sit nam voluptatibus.</h1>
			</tab>

			<tab name="about us 3">
				<h1>3 Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dignissimos iste itaque tempora impedit magnam, quia vitae reiciendis nesciunt doloremque accusamus totam quasi iure quod voluptas exercitationem illo sit nam voluptatibus.</h1>
			</tab>
		</tabs>
	</div>
	<script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>

	<script type="text/javascript">
		Vue.component('tabs',{
			template: `
				<div>
					<div class="tabs">
						<ul>
							<li v-for="tab in tabs" :class="{ 'is-active' : tab.isActive }">
								<a :href="tab.href()" @click="selectTab(tab)">{{ tab.name }}</a>
							</li>
						</ul>
					</div>

					<div class="tabs-details">
						<slot></slot>
					</div>
				</div>
			`,
			data() {
				return {
					tabs: []
				}
			},
			created() {
				this.tabs = this.$children;
			},
			methods: {
				selectTab(slTab) {
					this.tabs.map(tab => {
						tab.isActive = (slTab.name == tab.name);
					});
				}
			}
		});

		Vue.component('tab',{
			template: `
				<div v-show="isActive"><slot></slot></div>
			`,
			props: {
				name: { required: true },
				selected: { default: false }
			},
			data() {
				return {
					isActive: false
				}
			},
			mounted() {
				this.isActive = this.selected;
			},
			methods: {
				href() {
					return '#' + this.name.toLowerCase().replace(/ /g, '-');
				}
			}
		});

		let app = new Vue({
			el: '#root'
		});
	</script>
</body>
</html>